module LeftistHeap where

import Data.Function (on)
import Data.Ord (comparing)
import Data.List (unfoldr)

-- Minimum Priority Queue
type PriorityQueue p a = LeftistHeap (Entry p a)

data Entry p a = Entry { payload :: a, priority :: p }
    deriving Show

instance Eq p => Eq (Entry p a) where
    (==) = (==) `on` priority

instance Ord p => Ord (Entry p a) where
    compare = comparing priority

data LeftistHeap a 
    = Leaf
    | Fork 
        Int             -- rank
        a               -- element
        (LeftistHeap a) -- left child
        (LeftistHeap a) -- right child
    deriving (Show, Eq)

empty :: Ord a => LeftistHeap a
empty = undefined

rank :: Ord a => LeftistHeap a -> Int
rank = undefined

makeFork :: Ord a => a -> LeftistHeap a -> LeftistHeap a -> LeftistHeap a
makeFork = undefined

merge :: Ord a => LeftistHeap a -> LeftistHeap a -> LeftistHeap a
merge = undefined

insert :: Ord a => a -> LeftistHeap a -> LeftistHeap a
insert = undefined

viewMin :: Ord a => LeftistHeap a -> Maybe a
viewMin = undefined

extractMin :: Ord a => LeftistHeap a -> Maybe (a, LeftistHeap a)
extractMin = undefined

-- Convert a leftist heap to a list of elements.
toList :: Ord a => LeftistHeap a -> [a]
toList = unfoldr extractMin

-- Create a leftist heap from a list of elements.
fromList :: Ord a => [a] -> LeftistHeap a
fromList = foldr insert empty
